/*
 * const.h
 *
 *  Created on: 2014/2/13
 *      Author: 300210
 */

#ifndef CONST_H_
#define CONST_H_

/*
 * Ψөwqbit fieldmacro
 *
 * d:
 *   setbit (var, BITS(3,1), 5)  |Nbit3~1]101
 *   getbit (var, BITS(3,1)) |Ǧ^bit3~1ȡAd0~7
 *   merge (BITS(3,2),BITS(1,0)) P BITS(3,0)
 *
 * wqbit fieldk:
 *   #define F_some_field BITS(3,1)
 * ϥήɡAsetbit(reg, F_some_field, 3)  getbit(reg, F_some_field)
 * ϥ getbit(var, merge(BITS(3,3),BITS(1,1))) |o101,100,001,000|صG
 */
#define min(a,b)				((a) < (b) ? (a) : (b))
#define mask(a,b)				(((1<<((a)-(b)+1))-1)<<(b))
#define BITS(a,b)				mask(a,b),b
#define bitmask(a,b)			a
#define bitoffset(a,b)			b
#define getbit(var,bits)		(((var) & bitmask(bits)) >> bitoffset(bits))
#define setbit(var,bits,val)	((var) = ((var) & (~bitmask(bits))) | (((val) << bitoffset(bits)) & bitmask(bits)))
#define merge(a,b)				(bitmask(a)|bitmask(b)),min(bitoffset(a),bitoffset(b))

// iHKXYbyteAҦp getbit(reg, byte2)
#define byte0					BITS(7,0)
#define byte1					BITS(15,8)
#define byte2					BITS(23,16)
#define byte3					BITS(31,24)

// iHKXYbitAҦp getbit(reg, bit5)
#define bit0					BITS(0,0)
#define bit1					BITS(1,1)
#define bit2					BITS(2,2)
#define bit3					BITS(3,3)
#define bit4					BITS(4,4)
#define bit5					BITS(5,5)
#define bit6					BITS(6,6)
#define bit7					BITS(7,7)



/*
 * wq`Ϊ type
 */
typedef unsigned int			uint;
typedef unsigned short			ushort;
typedef unsigned char			uchar;



/*
 * бN global variable wqbo
 * d:
 *   extern int var;
 *   extern char str[50];
 *
 * volatile: ɭԻݭnΦr?
 *   1.ܼƷ|Q ISR 
 *   2.ܼƹM device register
 *   3.ܼƳQh threads @
 */
#ifdef __MAIN__
#define extern
#endif

extern uint jitter_ms;

#ifdef __MAIN__
#undef extern
#endif

#endif /* CONST_H_ */
