/*
 * N903.c
 *
 *  Created on: 2014/2/13
 *      Author: 300210
 *
 *  Please put all Andes native functions in this file
 */

#include <stdio.h>		// for fflush()
#include <stdlib.h>		// for exit()
#include "N903_reg.h"
#include "const.h"
#include "reg.h"

/*
 * Default_Handler Ow]_Bz禡A̭򳣤@
 */
#pragma weak tlb_exception_handler   = Default_Handler
#pragma weak error_exception_handler = Default_Handler
#pragma weak syscall_handler         = Default_Handler
//#pragma weak HW0_ISR   = Default_Handler
#pragma weak HW1_ISR   = Default_Handler
#pragma weak HW2_ISR   = Default_Handler
#pragma weak HW3_ISR   = Default_Handler
#pragma weak HW4_ISR   = Default_Handler
#pragma weak HW5_ISR   = Default_Handler
#pragma weak SW0_ISR   = Default_Handler
#pragma weak VEP0_ISR  = Default_Handler
#pragma weak VEP1_ISR  = Default_Handler
#pragma weak VEP2_ISR  = Default_Handler
#pragma weak VEP3_ISR  = Default_Handler
#pragma weak VEP4_ISR  = Default_Handler
#pragma weak VEP5_ISR  = Default_Handler
#pragma weak VEP6_ISR  = Default_Handler
#pragma weak VEP7_ISR  = Default_Handler
#pragma weak VEP8_ISR  = Default_Handler
#pragma weak VEP9_ISR  = Default_Handler
#pragma weak VEP10_ISR = Default_Handler
#pragma weak VEP11_ISR = Default_Handler
#pragma weak VEP12_ISR = Default_Handler
#pragma weak VEP13_ISR = Default_Handler
#pragma weak VEP14_ISR = Default_Handler
#pragma weak VEP15_ISR = Default_Handler
#pragma weak VEP16_ISR = Default_Handler
#pragma weak VEP17_ISR = Default_Handler
#pragma weak VEP18_ISR = Default_Handler
#pragma weak VEP19_ISR = Default_Handler
#pragma weak VEP20_ISR = Default_Handler
#pragma weak VEP21_ISR = Default_Handler
#pragma weak VEP22_ISR = Default_Handler
#pragma weak VEP23_ISR = Default_Handler
#pragma weak VEP24_ISR = Default_Handler
#pragma weak VEP25_ISR = Default_Handler
#pragma weak VEP26_ISR = Default_Handler
#pragma weak VEP27_ISR = Default_Handler
#pragma weak VEP28_ISR = Default_Handler
#pragma weak VEP29_ISR = Default_Handler
#pragma weak VEP30_ISR = Default_Handler
#pragma weak VEP31_ISR = Default_Handler
#pragma weak VEP32_ISR = Default_Handler
#pragma weak VEP33_ISR = Default_Handler
#pragma weak VEP34_ISR = Default_Handler
#pragma weak VEP35_ISR = Default_Handler
#pragma weak VEP36_ISR = Default_Handler
#pragma weak VEP37_ISR = Default_Handler
#pragma weak VEP38_ISR = Default_Handler
#pragma weak VEP39_ISR = Default_Handler
#pragma weak VEP40_ISR = Default_Handler
#pragma weak VEP41_ISR = Default_Handler
#pragma weak VEP42_ISR = Default_Handler
#pragma weak VEP43_ISR = Default_Handler
#pragma weak VEP44_ISR = Default_Handler
#pragma weak VEP45_ISR = Default_Handler
#pragma weak VEP46_ISR = Default_Handler
#pragma weak VEP47_ISR = Default_Handler
#pragma weak VEP48_ISR = Default_Handler
#pragma weak VEP49_ISR = Default_Handler
#pragma weak VEP50_ISR = Default_Handler
#pragma weak VEP51_ISR = Default_Handler
#pragma weak VEP52_ISR = Default_Handler
#pragma weak VEP53_ISR = Default_Handler
#pragma weak VEP54_ISR = Default_Handler
#pragma weak VEP55_ISR = Default_Handler
#pragma weak VEP56_ISR = Default_Handler
#pragma weak VEP57_ISR = Default_Handler
#pragma weak VEP58_ISR = Default_Handler
#pragma weak VEP59_ISR = Default_Handler
#pragma weak VEP60_ISR = Default_Handler
#pragma weak VEP61_ISR = Default_Handler
#pragma weak VEP62_ISR = Default_Handler
#pragma weak VEP63_ISR = Default_Handler

/*
 * This function is used as default interrupt handler
 */
__attribute__((unused)) static void Default_Handler()
{
}

/*
 * 禡Oئbcrtexit.o̭A]compileﶵèS]tw]start/exit file(ctr0.o/crtexit.o)
 * ҥHݭnʼgoӨ禡AHקKlink error~
 */
void abort(void)
{
	fflush(stdout);
	exit(1);
}



/*
 * bcrt0.S|Is禡A~|Ismain()
 * PCPUlƦAb禡
 * CyWnDglobal variableM0Ao]b禡
 */
void __attribute__ ((optimize("Os"))) __cpu_init()
{
	N903_Write (NDS32_SR_IVB, 0);	// interrupt vector size is 4-byte

	N903_SetBit (NDS32_SR_PSW, F_psw_intl, 0);	// INTL(current interrupt level) = 0

	N903_SetBit (NDS32_SR_INT_MASK, F_int_hw_mask, 1);	// enable HW0 interrupts
	N903_SetBit (NDS32_SR_INT_MASK, F_int_sw_mask, 1);	// enable software interrupt

	GIE_ENABLE();

#ifdef XIP_MODE
	extern char __data_lmastart;
	extern char __data_start;
	extern char _edata;
	/* Copy data section to RAM */
	__builtin_memcpy (&__data_start, &__data_lmastart, (uint)(&_edata - &__data_start));

	extern char _end;
	extern char __bss_start;
	/* Clear bss section */
	__builtin_memset (&__bss_start, 0, (uint)(&_end - &__bss_start));
#endif
}
