/*
 * fsm.cpp
 *
 *  Created on: 2014/4/7
 *      Author: 300210
 */

#include "fsm.h"

void Dummy() {
}

bool Always_True() {
	return true;
}

const FSM_State fsm_dummy = {
		Dummy, /* entry_action() */
		Always_True, /* is_success() */

		0, /* success_limit */
		&fsm_dummy, /* success_state */
		Dummy, /* exit_success */

		0, /* fail_limit */
		&fsm_dummy, /* fail_state */
		Dummy, /* exit_fail */

		0, /* timeout_limit */
		&fsm_dummy, /* timeout_state */
		Dummy, /* exit_timeout */
};

/*
 * Ystate
 */
void FSM_Object::GoToState(const FSM_State *new_state)
{
	state = new_state;
	entry_done = false;
}

/*
 * ΨӦbmain.cppwIsAstateʧ@
 */
void FSM_Object::ProcState()
{
	if (entry_done == false) {
		state->entry_action();
		success_time = jitter_ms + state->success_limit;
		fail_time = jitter_ms + state->fail_limit;
		timeout_time = jitter_ms + state->timeout_limit;
		entry_done = true;
		return;
	}

	// timeoutpGexit functionAøtimeout state
	if (state->timeout_limit > 0) {
		if ((jitter_ms - timeout_time) > 0 && (jitter_ms - timeout_time) < 5) {
			state->exit_timeout();
			GoToState (state->timeout_state);
			return;
		}
	}

	if (state->success_limit <= 0 && state->fail_limit <= 0)
		return;

	bool result = state->is_success();

	if (result == true)
	{
		// ]X{successAҥHfail_timespAڭ̥u"s"success or fail
		fail_time = jitter_ms + state->fail_limit;

		// successpGexit functionAøsuccess state
		if (state->success_limit > 0) {
			if ((jitter_ms - success_time) > 0 && (jitter_ms - success_time) < 5) {
				state->exit_success();
				GoToState (state->success_state);
			}
		}
	}
	else
	{
		// ]X{failAҥHsuccess_timespAڭ̥u"s"success or fail
		success_time = jitter_ms + state->success_limit;

		// successpGexit functionAøsuccess state
		if (state->fail_limit > 0) {
			if ((jitter_ms - fail_time) > 0 && (jitter_ms - fail_time) < 5) {
				state->exit_fail();
				GoToState (state->fail_state);
			}
		}
	}
}

